tigase.server.xmppclient

## Interface SeeOtherHostIfc

- All Known Implementing Classes:
    SeeOtherHost, SeeOtherHostDB, SeeOtherHostDualIP, SeeOtherHostHashed

      public interface SeeOtherHostIfc

  Author:
    Wojtek

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `SeeOtherHostIfc.Phase`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `CM_SEE_OTHER_HOST_ACTIVE`
    `static String` | `CM_SEE_OTHER_HOST_CLASS_PROP_DEF_VAL`
    `static String` | `CM_SEE_OTHER_HOST_CLASS_PROP_DEF_VAL_CLUSTER`
    `static String` | `CM_SEE_OTHER_HOST_CLASS_PROP_KEY`
    `static String` | `CM_SEE_OTHER_HOST_CLASS_PROPERTY`
    `static String` | `CM_SEE_OTHER_HOST_DEFAULT_HOST`
    `static String` | `CM_SEE_OTHER_HOST_DEFAULT_PORT`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `BareJID` | `findHostForJID(BareJID jid, BareJID host)` Finds an appropriate host for a given JID
    `void` | `getDefaults(Map<String,Object> defs, Map<String,Object> params)`
    `default Element` | `getStreamError(String xmlns, BareJID destination, Integer port)` Returns Element object containing stream:error message
    `boolean` | `isEnabled(VHostItem vHost, SeeOtherHostIfc.Phase ph)` Performs check whether redirect is enabled in the given phase by default see-other-host redirect is only active in stream:open phase
    `default boolean` | `isRedirectionRequired(BareJID defaultHost, BareJID redirectionHost)` Method validates whether a redirection for a particular hostname and resulting redirection hastname is required
    `void` | `setNodes(List<JID> nodes)` Sets list of available nodes in cluster environment
    `void` | `setProperties(Map<String,Object> props)`

- - ### Field Detail

    - #### CM_SEE_OTHER_HOST_CLASS_PROPERTY

          static final String CM_SEE_OTHER_HOST_CLASS_PROPERTY

      See Also:
        Constant Field Values

    - #### CM_SEE_OTHER_HOST_CLASS_PROP_KEY

          static final String CM_SEE_OTHER_HOST_CLASS_PROP_KEY

      See Also:
        Constant Field Values

    - #### CM_SEE_OTHER_HOST_CLASS_PROP_DEF_VAL

          static final String CM_SEE_OTHER_HOST_CLASS_PROP_DEF_VAL

      See Also:
        Constant Field Values

    - #### CM_SEE_OTHER_HOST_CLASS_PROP_DEF_VAL_CLUSTER

          static final String CM_SEE_OTHER_HOST_CLASS_PROP_DEF_VAL_CLUSTER

      See Also:
        Constant Field Values

    - #### CM_SEE_OTHER_HOST_DEFAULT_HOST

          static final String CM_SEE_OTHER_HOST_DEFAULT_HOST

      See Also:
        Constant Field Values

    - #### CM_SEE_OTHER_HOST_DEFAULT_PORT

          static final String CM_SEE_OTHER_HOST_DEFAULT_PORT

      See Also:
        Constant Field Values

    - #### CM_SEE_OTHER_HOST_ACTIVE

          static final String CM_SEE_OTHER_HOST_ACTIVE

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### findHostForJID

          BareJID findHostForJID(BareJID jid,
                                 BareJID host)

      Finds an appropriate host for a given JID
      Parameters:
        `jid` - is a user JID extracted from the stream open attributes
        `host` - is "this" host to which the user is now connected and which calls the method
      Returns:
        BareJID of possible host to which the user should connect or NULL

    - #### setNodes

          void setNodes(List<JID> nodes)

      Sets list of available nodes in cluster environment
      Parameters:
        `nodes` - current list of nodes

    - #### getDefaults

          void getDefaults(Map<String,Object> defs,
                           Map<String,Object> params)

    - #### setProperties

          void setProperties(Map<String,Object> props)

    - #### getStreamError

          default Element getStreamError(String xmlns,
                                         BareJID destination,
                                         Integer port)

      Returns Element object containing stream:error message
      Parameters:
        `xmlns` - xml namespace of the element
        `destination` - BareJID address of the redirect destination
      Returns:
        element containing stream:error message

    - #### isEnabled

          boolean isEnabled(VHostItem vHost,
                            SeeOtherHostIfc.Phase ph)

      Performs check whether redirect is enabled in the given phase by default see-other-host redirect is only active in stream:open phase
      Parameters:
        `vHost` - vHost for which redirection should be performed
        `ph` - phase for which the check should be performed
      Returns:
        boolean value indicating whether to perform or not redirect for the phase passed as argument

    - #### isRedirectionRequired

          default boolean isRedirectionRequired(BareJID defaultHost,
                                                BareJID redirectionHost)

      Method validates whether a redirection for a particular hostname and resulting redirection hastname is required
      Parameters:
        `defaultHost` - default hostname of the particular machine
        `redirectionHost` - destination hostname
      Returns:
        `true` if the redirection is required, otherwise `false`

Copyright © 2022 "Tigase, Inc.". All rights reserved.